clear;clc;close all;
rng(10);


n = 6000; p = 5;
% n = 8000; p = 6;

fprintf('n:%d, p:%d\n', n, p);

h = 1 / (n + 1);
A = 1 / h^2 * spdiags(ones(n, 1) * [-1 2 -1], [-1 0 1], n, n);    
M = spdiags([rand(n-1, 1); 0] + 0.1, [0], n, n);
% M = speye(n);
LM = chol(M, 'lower');
b = randn(n, 1);
B = [];


Y = randn(n, p);
% Y = Y / norm(Y, 'fro');
initialX.main = Y ;

% parameters for the manifold
ManiParams.name = 'SymFixedRankQ';
ManiParams.n = n;
ManiParams.p = p;
 
HasHHR = 0;
% parameters for solvers    
ManiParams.IsCheckParams = 0;
SolverParams.IsCheckParams = 0;
SolverParams.IsCheckGradHess = 0;
SolverParams.Min_Iteration = 1;
SolverParams.Max_Iteration = 150;
SolverParams.OutputGap = 1;
SolverParams.Verbose = 2;
SolverParams.Accuracy = 1e-12;
SolverParams.Tolerance = 1e-13;
SolverParams.Max_Inner_Iter = 300;
SolverParams.DEBUG = 0;

% ParamSet: 
%   1: first metric on R^{n \times p}_*; vector transport by parallelization
%   4: first metric on R^{n \times p}_*; vector transport by projection
%   2: second metric on R^{n \times p}_*; vector transport by parallelization
%   5: second metric on R^{n \times p}_*; vector transport by projection
%   3: third metric on R^{n \times p}_*; vector transport by parallelization
%   6: third metric on R^{n \times p}_*; vector transport by projection

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RNewton non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'RNewton';
SolverParams.Num_pre_funs = 0;
ManiParams.ParamSet = 1;
preconditioner = 1;
SolverParams.IsCheckGradHess = 0;
[FinalX_RNewton, fv_RNewton, gfv_RNewton, gfgf0_RNewton, iter_RNewton, nf_RNewton, ng_RNewton, nR_RNewton, nV_RNewton, nVp_RNewton, nH_RNewton, ComTime_RNewton, funs_RNewton, grads_RNewton, times_RNewton, eigHess_RNewton] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RTRNewton non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'RTRNewton';
% SolverParams.Num_pre_funs = 1;
ManiParams.ParamSet = 1;
preconditioner = 1;
SolverParams.initial_Delta = 1e10;  % TR-type
SolverParams.maximum_Delta = 1e14; % TR-type
SolverParams.IsCheckGradHess = 0;
[FinalX_RTRNewton, fv_RTRNewton, gfv_RTRNewton, gfgf0_RTRNewton, iter_RTRNewton, nf_RTRNewton, ng_RTRNewton, nR_RTRNewton, nV_RTRNewton, nVp_RTRNewton, nH_RTRNewton, ComTime_RTRNewton, funs_RTRNewton, grads_RTRNewton, times_RTRNewton, eigHess_RTRNewton] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% LRBFGS non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'LRBFGS';
SolverParams.Num_pre_funs = 0;
ManiParams.ParamSet = 1;
SolverParams.LengthSY = 2;
preconditioner = 1;
SolverParams.IsCheckGradHess = 0;
[FinalX_LRBFGS1, fv_LRBFGS1, gfv_LRBFGS1, gfgf0_LRBFGS1, iter_LRBFGS1, nf_LRBFGS1, ng_LRBFGS1, nR_LRBFGS1, nV_LRBFGS1, nVp_LRBFGS1, nH_LRBFGS1, ComTime_LRBFGS1, funs_LRBFGS1, grads_LRBFGS1, times_LRBFGS1, eigHess_LRBFGS1] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% LRBFGS non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'LRBFGS';
SolverParams.Num_pre_funs = 0;
ManiParams.ParamSet = 1;
SolverParams.LengthSY = 4;
preconditioner = 1;
SolverParams.IsCheckGradHess = 0;
[FinalX_LRBFGS2, fv_LRBFGS2, gfv_LRBFGS2, gfgf0_LRBFGS2, iter_LRBFGS2, nf_LRBFGS2, ng_LRBFGS2, nR_LRBFGS2, nV_LRBFGS2, nVp_LRBFGS2, nH_LRBFGS2, ComTime_LRBFGS2, funs_LRBFGS2, grads_LRBFGS2, times_LRBFGS2, eigHess_LRBFGS2] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RCG non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'RCG';
SolverParams.Num_pre_funs = 0;
% SolverParams.LineSearch_LS = 2;
% SolverParams.InitSteptype = 2;
ManiParams.ParamSet = 1;
SolverParams.Accuracy = 0.;
% SolverParams.LS_ratio1 = 0.09;
% SolverParams.LS_ratio2 = 0.1;
% SolverParams.RCGmethod = 0;
preconditioner = 1;
SolverParams.IsCheckGradHess = 0;
[FinalX_RCG1, fv_RCG1, gfv_RCG1, gfgf0_RCG1, iter_RCG1, nf_RCG1, ng_RCG1, nR_RCG1, nV_RCG1, nVp_RCG1, nH_RCG1, ComTime_RCG1, funs_RCG1, grads_RCG1, times_RCG1, eigHess_RCG1] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RCG non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'RCG';
SolverParams.Num_pre_funs = 0;
ManiParams.ParamSet = 4;
preconditioner = 1;
SolverParams.IsCheckGradHess = 0;
[FinalX_RCG2, fv_RCG2, gfv_RCG2, gfgf0_RCG2, iter_RCG2, nf_RCG2, ng_RCG2, nR_RCG2, nV_RCG2, nVp_RCG2, nH_RCG2, ComTime_RCG2, funs_RCG2, grads_RCG2, times_RCG2, eigHess_RCG2] = ...
 LyapunovLR(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);



figure(1)
t = 0:iter_RNewton;
semilogy(t,grads_RNewton, '-o','LineWidth',1,'MarkerSize',5);

hold on
figure(1)
t = 0:iter_RTRNewton;
semilogy(t,grads_RTRNewton, '-x','LineWidth',1,'MarkerSize',5);

hold on
figure(1)
t = 0:iter_RCG1;
semilogy(t,grads_RCG1, '-+','LineWidth',1,'MarkerSize',5);


hold on
figure(1)
t = 0:iter_RCG2;
semilogy(t,grads_RCG2, '-*','LineWidth',1,'MarkerSize',5);

hold on
figure(1)
t = 0:iter_LRBFGS1;
semilogy(t,grads_LRBFGS1, '-^','LineWidth',1,'MarkerSize',5);

hold on
figure(1)
t = 0:iter_LRBFGS2;
semilogy(t,grads_LRBFGS2, '->','LineWidth',1,'MarkerSize',5);

xlabel('iteration','FontSize',20)
ylabel('norm of gradient','FontSize',20)
legend('RNewton', 'RTRNewton', 'RCG, VT1', 'RCG, VT2', 'LRBFGS, m=2', 'LRBFGS, m=4','FontSize',16)

figure(2)
semilogy(times_RNewton, grads_RNewton, '-o','LineWidth',1,'MarkerSize',5);

hold on
figure(2)
semilogy(times_RTRNewton, grads_RTRNewton, '-x','LineWidth',1,'MarkerSize',5);

hold on
figure(2)
semilogy(times_RCG1,grads_RCG1, '-+','LineWidth',1,'MarkerSize',5);


hold on
figure(2)
semilogy(times_RCG2,grads_RCG2, '-+','LineWidth',1,'MarkerSize',5);

hold on
figure(2)
semilogy(times_LRBFGS1, grads_LRBFGS1, '-^','LineWidth',1,'MarkerSize',5);

hold on
figure(2)
semilogy(times_LRBFGS2, grads_LRBFGS2, '->','LineWidth',1,'MarkerSize',5);

xlabel('time','FontSize',20)
ylabel('norm of gradient','FontSize',20)
legend('RNewton', 'RTRNewton', 'RCG, VT1', 'RCG, VT2', 'LRBFGS, m=2', 'LRBFGS, m=4','FontSize',16)

saveas(1, string(n) + 'x' + string(p) + '_iter.fig')
saveas(2, string(n) + 'x' + string(p) + '_time.fig')



