clear;clc;close all;

seed = 2;

rng(seed);

n = 50000;
p = 12;

fprintf('seed:%d, n:%d, p:%d\n', seed, n, p);

h = 1 / (n + 1);
A = 1 / h^2 * spdiags(ones(n, 1) * [-1 2 -1], [-1 0 1], n, n);    
M = spdiags([rand(n-1, 1); 0] + 0.1, [0], n, n);
% M = speye(n);
LM = chol(M, 'lower');
b = randn(n, 1);
B = [];

% V = orth(randn(n,p));
% D = abs(rand(p,1));
% D = sort(D, 'descend');
% D = diag(D);

Y = randn(n, p);
% Y = Y / norm(Y);
[V, S, ~] = svd(Y, 0);

norm(Y, 'fro')

initialX.main = [V(:); S(:)];

% parameters for the manifold
ManiParams.name = 'SymFixedRankE';
ManiParams.n = n;
ManiParams.p = p;
 
ManiParams.IsCheckParams = 0;
HasHHR = 0;
% parameters for solvers    
SolverParams.IsCheckParams = 0;
SolverParams.IsCheckGradHess = 0;
SolverParams.Min_Iteration = 1;
SolverParams.Max_Iteration = 150;
SolverParams.OutputGap = 1;
SolverParams.Verbose = 2;
SolverParams.Tolerance = 1e-11;
SolverParams.Accuracy = 1e-12;
SolverParams.Max_Inner_Iter = 100;
SolverParams.DEBUG = 0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RNewton non preconditioner under the first metric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SolverParams.method = 'RNewton';
% SolverParams.method = 'RTRNewton';
SolverParams.initial_Delta = 1e15;       % TR-type
SolverParams.maximum_Delta = 1e15; % TR-type
SolverParams.InitSteptype = 0;
SolverParams.Num_pre_funs = 0;

preconditioner = 1;
fprintf("precond.:%d\n", preconditioner)
[FinalX1np, fv1np, gfv1np, gfgf01np, iter1np, nf1np, ng1np, nR1np, nV1np, nVp1np, nH1np, ComTime1np, funs1np, grads1np, times1np, eigHess1np] = ...
 LyapunovLRE(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);

preconditioner = 2;

fprintf("\nprecond.:%d\n", preconditioner)
[FinalX1np, fv1np, gfv1np, gfgf01np, iter1np, nf1np, ng1np, nR1np, nV1np, nVp1np, nH1np, ComTime1np, funs1np, grads1np, times1np, eigHess1np] = ...
 LyapunovLRE(A, M, LM, B, b, n, p, ManiParams, SolverParams, HasHHR, initialX, preconditioner);
