//
//  SFREQuadratic.h
//  ROPTLIB_20221123
//
//  Created by dagoubangtulongdao on 2023/12/30.
//

#ifndef SFRELyap_h
#define SFRELyap_h

#include "Manifolds/SymFixedRankE.h"
#include "Problems/Problem.h"
#include "Others/def.h"

/*Define the namespace*/
namespace ROPTLIB{

    class SFRELyap : public Problem{
    public:
        SFRELyap(Vector A, Vector M, Vector b, realdp n, realdp p);
        virtual ~SFRELyap(void);
        virtual realdp f(const Variable &x) const;
        virtual Vector &EucGrad(const Variable &x, Vector *result) const;
        virtual Vector &EucHessianEta(const Variable &x, const Vector &etax, Vector *result) const;
        
        Vector A, M, b;
        realdp n, p;
    };
}; /*end of ROPTLIB namespace*/
#endif /* SFREQuadratic_h */
